import OntologiaTurismo.*;
import OntologiaTurismo.TourismOntology.*;
import jade.core.*;
import jade.core.behaviours.*;
import jade.content.onto.*;
import jade.content.lang.*;
import jade.content.lang.leap.*;
import jade.content.lang.sl.*;
import jade.content.lang.Codec.*;
import jade.content.onto.basic.*;
import jade.domain.*;
import jade.domain.DFService;
import jade.content.*;
import jade.domain.*;
import jade.lang.acl.*;
//import jade.imtp.leap.*;
import jade.domain.FIPAAgentManagement.*;
import jade.util.leap.*;
import java.util.Vector;
import jade.gui.*;
import java.io.*;
import java.util.GregorianCalendar;
import java.util.Date;
import java.util.Calendar;


/**Class UserAgent*/
public class NUserAgent extends GuiAgent {

public Codec codec = new SLCodec();
public Ontology ontology ;
public AID MiBroker;
public Color myGui;
public AID MiPlanner;
public boolean disconnected;


int command;
int i;
public String curo[];
public String curi, linea;
public String cure;
public SimpleSearchList arg;
public String time1;
public long start;
public Restaurant Recomendado;

protected void setup()
{
// Register language and ontology
      getContentManager().registerLanguage(codec);
      ontology = TourismOntology.getInstance();
      getContentManager().registerOntology(ontology);
      myGui = new Color(this);
      myGui.inicio(this);
      myGui.show();
      Busqbroker();
      BusqPlanner(); 
      
}

 public void handleDisconnection(){
     disconnected = true;    
}

protected void onGuiEvent(GuiEvent ev) {
    
command = ev.getType();

switch (command){

case 1:
   Restaurant Corral = new Restaurant();
   Corral = (Restaurant)ev.getParameter(0);       
  addBehaviour(new Busqueda(this, Corral));
break;

case 2: 
   String People =(String) ev.getParameter(0);
   Calendar Tiem = (Calendar) ev.getParameter(1);
   Restaurant Popsy = new Restaurant();
   Popsy = (Restaurant)ev.getParameter(2); 
   AID cedula = (AID) ev.getParameter(3);
   String valfechas = (String) ev.getParameter(4);
   int ao = Integer.parseInt(valfechas);
   valfechas = (String) ev.getParameter(5);
   int meso = Integer.parseInt(valfechas);
   valfechas = (String) ev.getParameter(6);
   int fecho = Integer.parseInt(valfechas);
   valfechas = (String) ev.getParameter(7);
   int houro = Integer.parseInt(valfechas);
   valfechas = (String) ev.getParameter(8);
   int mino = Integer.parseInt(valfechas);
   addBehaviour(new Reserva(this, People, Tiem, Popsy, cedula, ao, meso, fecho, houro, mino));
break;

case 3: 
   Museum muse =(Museum)ev.getParameter(0);
   addBehaviour(new Busqueda(this, muse));
break;

case 4:
    String idcan  = (String)ev.getParameter(0);
    AID Acan = new AID();
     String ai =(String) ev.getParameter(1);
     Acan.setName(ai);
     //Acan.addAddresses(ai);
     addBehaviour(new Cancel(this, idcan, Acan));
       
break;


case 5:
   Restaurant Presto = new Restaurant();
   Restaurant Presto1 = new Restaurant();
   Presto = (Restaurant)ev.getParameter(0);   
   Presto1 = (Restaurant)ev.getParameter(1);       
   String blanco = (String) ev.getParameter(2);
   addBehaviour(new PlanBehav(this, Presto, Presto1, blanco));
       
break;

case 6:
   Theatre teatre =(Theatre)ev.getParameter(0);
   addBehaviour(new Busqueda(this, teatre)); 
        
break;

case 7:
   Cinema cinema =(Cinema)ev.getParameter(0);
   addBehaviour(new Busqueda(this, cinema));      
break; 

case 8: 
    Place lugar =(Place)ev.getParameter(0);
    addBehaviour(new Busqueda(this, lugar));
break;

case 9:
    ModifSearchList replan = (ModifSearchList)ev.getParameter(0);
    addBehaviour(new RePlanBehav(this, replan));
break;        
   
default: 
break;
}
}



//BEHAVIOURS
public class Busqueda extends Behaviour{
    private Sight Corral; 
    private MessageTemplate mt;
    private int pa =1;
    public Busqueda (Agent a, Sight Corral){
        super(a);
    this.Corral = Corral;
     }
     
    public void action() {

switch (pa){
case 1:
     SimpleSearch MySearch = new SimpleSearch();
     MySearch.setTourismTemplate(Corral);
     ACLMessage msg = new ACLMessage(ACLMessage.QUERY_REF);
     msg.addReceiver(MiBroker);
     msg.setLanguage("fipa-sl");
     msg.setOntology("TourismOntology");
     msg.setProtocol(FIPANames.InteractionProtocol.FIPA_QUERY);
     try {
        getContentManager().fillContent(msg,MySearch);
        int id = 1256;
        msg.setConversationId(Integer.toString(id));
        start = System.currentTimeMillis();
        time1 = " envio peticion busqueda: "+Long.toString(start)+time1;
        send(msg);
        
     }
      catch ( CodecException e)  { e.printStackTrace();}
      catch ( OntologyException a) { a.printStackTrace(); }
     System.out.println("Send Vale");
     pa ++;
break;

    case 2:
    mt = MessageTemplate.MatchProtocol(FIPANames.InteractionProtocol.FIPA_QUERY);
    ACLMessage reply = myAgent.receive(mt);
    if (reply == null)
    {block();
    return;} 
    long start1 = System.currentTimeMillis();
    time1 = " recepcion de respuesta: "+Long.toString(start1)+time1;
    start1 = start1 - start;
    time1 = " tiempo de roundtrip: "+Long.toString(start1)+time1;
    
    try{
        OutputStream fout= new FileOutputStream("tiempos.txt");
        OutputStream bout= new BufferedOutputStream(fout);
        OutputStreamWriter out = new OutputStreamWriter(bout, "8859_1");
        out.write(time1);
        out.flush();
        out.close();
    }
    catch (UnsupportedEncodingException e) {
        System.out.println(
         "This VM does not support the Latin-1 character set."
        );
      }
      catch (IOException e) {
        System.out.println(e.getMessage());
      }

    myAgent.doWait(2000);
    if( reply != null ){
    try{
    ContentElement a = getContentManager().extractContent(reply);
    arg= (SimpleSearchList) a;
    Sight sighty = (Sight) arg.getTourismTemplateList().get(0);
    if(sighty.getName() == null)
    myGui.vacio(Corral);
    else
    myGui.recibeResp(arg, 0);
    }    
catch(Exception e) { e.printStackTrace();}
    }
    pa ++;
    break;
}}
   public boolean done() {return pa == 3;}
  
}

public class Cancel extends Behaviour{

  public int pr =1;
  public String idcan;
  public AID aid;
   private MessageTemplate mtc;
   public boolean filecanc;
  

public Cancel (Agent a, String idcan,  AID aid){
     
    super(a);
     this.idcan = idcan;
     this.aid = aid;     
     }
 
   public void action() {
       
      switch (pr){
      case 1:
      Cancellation cancel = new Cancellation();
      cancel.setAgentsAID(myAgent.getAID());
      Time_period tp = new Time_period();
      System.out.println("antes de cancelar ");
      tp.setTime(idcan);
      cancel.setCancelTime(tp);
      
      ACLMessage msgc = new ACLMessage(ACLMessage.REQUEST);
      msgc.addReceiver(aid);
      msgc.setLanguage("fipa-sl");
      msgc.setOntology("TourismOntology");
      
      Action aa=new Action();
      aa.setAction(cancel);
      aa.setActor(myAgent.getAID());
     try {
        getContentManager().fillContent(msgc,aa);
        int id =55;
        msgc.setConversationId(Integer.toString(id));
        
        send(msgc);
     }
      catch ( CodecException e)  { e.printStackTrace();}
      catch ( OntologyException a) { a.printStackTrace(); }        
          
      pr ++;
      break;        
      
     case 2:
        
     ACLMessage reply = myAgent.receive();
      if (reply == null)
      {block();
      return;} 
      myAgent.doWait(2000);
      ContentElement a = null; 
      if( reply != null ){
      try{
      a = getContentManager().extractContent(reply);
      }    
       catch(Exception e) { e.printStackTrace();}
       }
      if (reply.getPerformative() == ACLMessage.AGREE)
      { 
          // se determina si el archivo de la resserva existe o no y se elimina
          //System.out.println("ID cancelacion para borar "+"C:\\jade\\Turismo\\PDAVersion1.0\\"+idcan+".txt");
          boolean excanc= (new File("PDATurismo\\"+idcan+".txt")).exists();
          
          if(excanc = true)
           filecanc = (new File("PDATurismo\\"+idcan+".txt")).delete();
          
          //ahora de la lista de resservas leemos las qeu hay y no tomamos la que corresponde a la cancelacion
                
       List canlist = new ArrayList();
       try{
           
            BufferedReader  fich = new BufferedReader(new FileReader("PDATurismo\\reservas.txt")); 
       do{
           linea = fich.readLine();    
           if(linea != null)
            {System.out.println("LINEA -- "+linea+" -- IDCAN "+idcan);
                if(linea.compareTo(idcan) != 0)
                canlist.add(linea);}
           }while(linea != null);
        }catch(IOException ioexception)
        {System.out.println(ioexception.getMessage());}  
          
      //Se crea el nuevo archivo de las reservas
       try{
      OutputStream fout= new FileOutputStream("PDATurismo\\reservas.txt");
      OutputStream bout= new BufferedOutputStream(fout);
      OutputStreamWriter out = new OutputStreamWriter(bout, "8859_1");
      
      
      for(i=0; i<(canlist.size()); i++)
      out.write((String) canlist.get(i)+"\n");
       
      out.flush();
      out.close();
       }catch(IOException ioexception)
        {System.out.println(ioexception.getMessage());}  
       
       
      myGui.resva(17, "cancel successful");
      pr = 4;
      }
      
      break;
      
     
      }
                        }
 
 
    public boolean done() {return pr == 4;}
    
}


public class Reserva extends Behaviour{
public int pr= 1;
public String peoples, todoall;
public Calendar tiempo;
public Restaurant Popsy;
public AID aid;
private MessageTemplate mt;
private int ao, meso, fecho, houro, mino;


public Reserva (Agent a, String peoples, Calendar tiempo, Restaurant Popsy, AID aid, int ao, int meso, int fecho, int houro, int mino){
     super(a);
     this.peoples = peoples;
     this.tiempo = tiempo;
     this.Popsy = Popsy;
     this.aid = aid;
     this.ao = ao;
     this.meso = meso;
     this.fecho = fecho;
     this.houro = houro;
     this.mino = mino;
     }
 
   public void action() {
       
      switch (pr){
      case 1:
      int id = 17;
      BookSight deox = new BookSight();
      deox.setSightTemplate(new Restaurant());
      //Recomendado es una variable para poder hacer la reserva con la recomendacion onjeto restaurante
      Recomendado = Popsy;
      deox.setName(Popsy.getName());
      Time_period period = new Time_period();
      //System.out.println("RESERVA "+tiempo.toString());
 
      //period.setTime(String.valueOf(tiempo.getTimeInMillis()));
      todoall =ao+"+"+meso+"+"+fecho+"+"+houro+"+"+mino+"-";
      period.setTime("DATA ON OTHER STRING");
      period.setTimebla(todoall);
      deox.setTimePeriod(period);
      deox.setNumberOfPeople(Integer.parseInt(peoples));
      ACLMessage msg = new ACLMessage(ACLMessage.CFP);
      msg.addReceiver(aid);
      msg.setLanguage("fipa-sl");
      msg.setOntology("TourismOntology");
      msg.setProtocol(FIPANames.InteractionProtocol.FIPA_CONTRACT_NET);
      try{
      getContentManager().fillContent(msg, deox);
      msg.setConversationId(Integer.toString(id));
      send(msg);   
      }    
      catch ( CodecException e)  { e.printStackTrace();}
      catch ( OntologyException a) { a.printStackTrace(); }
      pr ++;
      break;        
      
     case 2:
      mt = MessageTemplate.MatchProtocol(FIPANames.InteractionProtocol.FIPA_CONTRACT_NET);
      ACLMessage reply = myAgent.receive(mt);
      if (reply == null)
      {block();
      return;} 
      myAgent.doWait(2000);
      ContentElement a = null; 
      if( reply != null ){
      try{
      a = getContentManager().extractContent(reply);
      
      }    
       catch(Exception e) { e.printStackTrace();}
       }
      if (reply.getPerformative() == ACLMessage.REFUSE)
      {
        
      myGui.resva(17, "not successful");
      pr = 4;
      }
      else if(reply.getPerformative() == ACLMessage.PROPOSE)
      {
         BookSight res = (BookSight) a;
        // System.out.println("TIEMPO "+tiempo.getTimeInMillis()+" RES "+res.getTimePeriod().getTime());
         if (todoall.compareTo(res.getTimePeriod().getTimebla()) == 0)
         {
          Reserve re=new Reserve();
      re.setNumberOfVisitors(Integer.parseInt(peoples));
      Time_period t=new Time_period();
      //Cambiar tiempo por el valor del tiempo que llega y ajustar a que este sea el de rerecomendacion que ofresca el Sight
      t.setTime(res.getTimePeriod().getTime());
      re.setReserveTime(t);
      re.setAgentsAID(myAgent.getAID());
      Action aa=new Action();
      aa.setAction(re);
      aa.setActor(myAgent.getAID());
      ACLMessage msg2= reply.createReply();
      msg2.setPerformative(ACLMessage.ACCEPT_PROPOSAL);
      msg2.setProtocol(FIPANames.InteractionProtocol.FIPA_CONTRACT_NET);
      msg2.setLanguage("fipa-sl");
      msg2.setOntology("TourismOntology");
      try{
      getContentManager().fillContent(msg2,aa);
      send(msg2);
      }    
      catch ( CodecException e)  { e.printStackTrace();}
      catch ( OntologyException ao) { ao.printStackTrace(); }
      pr++;
         }
         else
         { myGui.setRecom(Recomendado, res, reply.getSender());
             myGui.resva(17, res.getTimePeriod().getTime());
             pr = 4;
         }
      
          
      }
      
      break;
      
      case 3:
      mt = MessageTemplate.MatchProtocol(FIPANames.InteractionProtocol.FIPA_CONTRACT_NET);
      ACLMessage reply2 = myAgent.receive(mt);
      if (reply2 == null)
      {block();
      return;} 
      List reservas = new ArrayList();
      try{
       BufferedReader fich = new BufferedReader(new FileReader("PDATurismo\\reservas.txt")); 
      
       
       do{
         
         linea = fich.readLine();
         if(linea != null)
         reservas.add(linea);
         
      } while(linea != null);
       ContentElement b = null; 
      b =  getContentManager().extractContent(reply2);
      if(b instanceof Action)
      {Action are = (Action) b;
       if(are.getAction() instanceof Reserve)
       {
      
      Reserve infores = (Reserve) are.getAction();
      reservas.add( String.valueOf(infores.getReserveTime().getTime()));
      OutputStream fout= new FileOutputStream("PDATurismo\\reservas.txt");
      OutputStream bout= new BufferedOutputStream(fout);
      OutputStreamWriter out = new OutputStreamWriter(bout, "8859_1");
      
      
      for(i=0; i<(reservas.size()); i++)
      {
          
          out.write((String) reservas.get(i)+"\n");
          
         
       }     
    
      out.flush();
      out.close();
      
      
      
      OutputStream fout1= new FileOutputStream("PDATurismo\\"+String.valueOf(infores.getReserveTime().getTime()) + ".txt");
      OutputStream bout1= new BufferedOutputStream(fout1);
      OutputStreamWriter out1 = new OutputStreamWriter(bout1, "8859_1");
      
      out1.write(String.valueOf(infores.getNumberOfVisitors())+"\n");
      out1.write(String.valueOf(reply2.getSender().getName())+"\n");
      
      out1.flush();
      out1.close();
       }
      }}
    catch (UnsupportedEncodingException e) {
        System.out.println(
         "This VM does not support the Latin-1 character set."
        );
      }
        catch(Exception e) { e.printStackTrace();}
       
      myGui.resva(17, "successful");
      pr++;
      break;
      }
                        }
 
 
    public boolean done() {return pr == 4;}
    
}




public class PlanBehav extends Behaviour{
 
    public Sight Wok;
    public Sight Wok1;
    public int pa = 1;
    public String maxsizeplan;
    private MessageTemplate mt;
    
    public PlanBehav (Agent a, Sight Wok, Sight Wok1, String maxsizeplan){
        super(a);  
         this.Wok = Wok;
         this.Wok1 = Wok1;
         this.maxsizeplan = maxsizeplan;
     }
     
   public void action() {

switch (pa){
case 1:
     SimpleSearch MySearch = new SimpleSearch();
     MySearch.setTourismTemplate(Wok);
     ACLMessage msg = new ACLMessage(ACLMessage.QUERY_REF);
     msg.addReceiver(MiPlanner);
     msg.setLanguage("fipa-sl");
     msg.setOntology("TourismOntology");
     msg.setProtocol(FIPANames.InteractionProtocol.FIPA_QUERY);
     try {
     getContentManager().fillContent(msg,MySearch);
        int id = Integer.parseInt(maxsizeplan);
        if(Wok.getName().compareTo("sitio1") == 0)
            id = id +100;
        if(Wok1.getName().compareTo("sitio2") == 0)
            id = id +100;
        
        msg.setConversationId(Integer.toString(id));
                
        send(msg);
     }
      catch ( CodecException e)  { e.printStackTrace();}
      catch ( OntologyException a) { a.printStackTrace(); }
     System.out.println("Send unnnnn  Vale");
     pa ++;
break;

    case 2:
    mt = MessageTemplate.MatchProtocol(FIPANames.InteractionProtocol.FIPA_QUERY);
    ACLMessage reply = myAgent.receive(mt);
    if (reply == null)
    {block();
    return;} 
   
    myAgent.doWait(2000);
    if( reply != null ){
    try{
    ContentElement a = getContentManager().extractContent(reply);
    arg= (SimpleSearchList) a;
    Sight sighty = (Sight) arg.getTourismTemplateList().get(0);
    if(sighty.getName() == null)
    myGui.plannoresult(Wok);
    else{
    ModifSearchList algo = new ModifSearchList();
    algo.setTourismTemplateList(arg.getTourismTemplateList());
    algo.setAgentAddresses(arg.getAgentAddresses());
   
    myGui.planresult(algo, Integer.parseInt(reply.getConversationId()));
    }
    }    
catch(Exception e) { e.printStackTrace();}
    }
    pa ++;
    break;
}}
   public boolean done() {return pa == 3;}

}

public class RePlanBehav extends Behaviour{
 
   private MessageTemplate mt;
   private ModifSearchList replab;
   private int pa=1;
    
    public RePlanBehav (Agent a, ModifSearchList replab){
        super(a);  
        
         this.replab = replab;
     }
     
   public void action() {
   switch (pa){
case 1:
     
     ACLMessage msg = new ACLMessage(ACLMessage.REQUEST);
     msg.addReceiver(MiPlanner);
     msg.setLanguage("fipa-sl");
     msg.setOntology("TourismOntology");
     
     try {
        getContentManager().fillContent(msg,replab);
               
        msg.setConversationId(Integer.toString(454));
                
        send(msg);
     }
      catch ( CodecException e)  { e.printStackTrace();}
      catch ( OntologyException a) { a.printStackTrace(); }
     System.out.println("Send unnnnn  Vale");
     pa ++;
break;

    case 2:
    /*mt = MessageTemplate.MatchProtocol(FIPANames.InteractionProtocol.FIPA_QUERY);
    ACLMessage reply = myAgent.receive(mt);
    if (reply == null)
    {block();
    return;} 
   
    myAgent.doWait(2000);
    if( reply != null ){
    try{
    ContentElement a = getContentManager().extractContent(reply);
    arg= (SimpleSearchList) a;
    Sight sighty = (Sight) arg.getTourismTemplateList().get(0);
    if(sighty.getName() == null)
    myGui.plannoresult(Wok);
    else{
    ModifSearchList algo = new ModifSearchList();
    algo.setTourismTemplateList(arg.getTourismTemplateList());
    algo.setAgentAddresses(arg.getAgentAddresses());
   
    myGui.planresult(algo, Integer.parseInt(reply.getConversationId()));
    }
    }    
catch(Exception e) { e.printStackTrace();}
    }
    pa ++;*/
        
    break;
}}
   public boolean done() {return pa == 2;}    
   
   }
   




AID Busqbroker()
{AID[] servidor = null;
  try{
DFAgentDescription dfd = new DFAgentDescription();
ServiceDescription sd = new ServiceDescription();
sd.setType("tourism-broker");
dfd.addServices(sd);
DFAgentDescription[] result = DFService.search(this, dfd);
if(result.length>0)
servidor = new AID[result.length];
for (int i = 0; i < result.length; ++i)
{servidor[i] = result[i].getName();}
MiBroker = servidor[0];
}
catch (FIPAException fe) {fe.printStackTrace();}
 return MiBroker;
 
}


AID BusqPlanner()
{AID[] servidor = null;
  try{
DFAgentDescription dfd = new DFAgentDescription();
ServiceDescription sd = new ServiceDescription();
sd.setType("tourism-plan");
dfd.addServices(sd);
DFAgentDescription[] result = DFService.search(this, dfd);
if(result.length>0)
servidor = new AID[result.length];
for (int i = 0; i < result.length; ++i)
{servidor[i] = result[i].getName();}
MiPlanner = servidor[0];
}
catch (FIPAException fe) {fe.printStackTrace();}
 return MiPlanner;
 
}



}


      
